#!/usr/bin/perl

use IO::Socket;

my $limit = 8000;
my ($table,$count) = read_cache();

my($sock, $newmsg, $hishost, $MAXLEN, $PORTNO);

$MAXLEN = 267;
$PORTNO = 53;

$SIG{INT} = sub { write_cache($table); };

$sock = IO::Socket::INET->new(
    LocalPort => $PORTNO, 
    Proto => 'udp') or die "socket: $@";

while ($sock->recv($newmsg, $MAXLEN))
{
    my($port, $ipaddr) = sockaddr_in($sock->peername);
    my @bytes = split(//,$newmsg);
    my ($url,$i,$bytes_ip,$bytes_url);

    for($i = 13; ord($bytes[$i]) != 0;$i++){ $url .= ord($bytes[$i]) < 32 ? "." : $bytes[$i]; }

    my $end = $i - 1;
    $bytes_url = join('',@bytes[12..$end]);

    next if(ord($bytes[$i+2]) == 0x1c);
    
    if(exists $table->{$url})
    {
        $bytes_ip = @{$table->{$url}}[0];
        @{$table->{$url}}[1]++;
        print "$url exists $bytes_ip\n";
    }
    else
    {
        print "$url existe pas $bytes_ip\n"; 
        delete $table->{least_use(\%table)} if($count == $limit);
        #$table->{$_}->[1]-- foreach(keys %table);

        $bytes_ip = get_bytes_ip($url);
        $table->{$url} = [$bytes_ip,1];
    }

    write_cache($table) if($count % 500 == 0);

    my $id = substr($newmsg,0,2);
    
    $reponse = pack("H*", "81800001000100000000"); # resonse
    $reponse .= $bytes_url;
    $reponse .= pack("H*","0000010001c00c00010001000002e50004$bytes_ip");# response

    $sock->send($id.$reponse);

} 
die print @!;

sub quit
{
    write_cache($table);
    exit 0;
}

sub get_bytes_ip
{
    my $url = shift;
    open(my $dig,'dig @208.67.222.222 '.$url.' +noall +answer|');

    my @lines = <$dig>;
    return "01020304" if($lines[-1] =~ /^;/);

    my $ip = (split(' ',$lines[-1]))[-1];
    print "$ip\n";
    close($dig);
    return unpack("H*",join('',map(chr,split(/[.]/,$ip))));
}

sub read_cache
{
    open(my $fh,'<','../cache');
    my (%cache,$count);

    while(<$fh>)
    {
        chomp;
        #next unless(/^\w+[.]\w+([.]\w+)*,\d{1,3}[.]\d{1,3}[.]\d{1,3}[.]\d{1,3},-?\d+$/);
        my ($key,@info) = split(',',$_);
        $cache{$key} = [@info];
        $count++;
    }
    close($fh);
    return (\%cache,$count);
}

sub write_cache
{
    my $cache = shift;
    open(my $fh,'>','/var/cache_dns');
    foreach(keys %$cache)
    {
        print $fh $_.",";
        print $fh join(',',@{$cache->{$_}})."\n";
    }    
    close($fh);
}

sub least_use
{
    my $cache = shift;    
    my ($min,$min_key);

    foreach(keys %$cache)
    {
        my $val = $cache->{$_}->[1];
        ($min,$min_key) = ($val,$_) if($val < $min); 
    }

    return ($min_key,$min);
}
