#include "msg.h"
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include "config.h"

void
info(char *m) { msg("INFO",m); }

void
warning(char *m) { msg("WARNING",m); }

void
error(char *m) { err("ERROR",m); }

void
fatal(int ret,char *m)
{
    if(ret < 0)
    {
        err("FATAL",m);
        exit(-1);
    }
}

void
msg(char *type_msg,char *m)
{
#ifdef DEBUG
    printf("%s : %s.\n",type_msg,m);
#endif
}

void
err(char *type_msg,char *m)
{
#ifdef DEBUG
      fprintf(stderr,"%s : %s. %s\n",type_msg,m,strerror(errno));
#endif
}
